from datetime import datetime
from parsers.FileListParser import FileListParser
from Process import Process
import json


class Collector:
    file_list_parser = FileListParser()
    data_dict = None

    def load_data(self):
        try:
            with open("/var/tmp/software_data.json", "r") as f:
                self.data_dict = json.load(f)
        except FileNotFoundError:
            self.data_dict = {"processes": {}}

    def collect_process_info(self, processes):
        for proc in processes.values():
            self.file_list_parser.add_open_files_to_process(proc)
        return processes

    def write_process_info(self, processes):
        collected_processes = self.collect_process_info(processes)
        for loaded_process in self.data_dict["processes"]:
            found = False
            for process in collected_processes:
                if loaded_process == process:
                    found = True
            if loaded_process in self.data_dict:
                if not found and self.data_dict[loaded_process]["running"]:
                    self.data_dict[loaded_process]["running"] = False
                    self.data_dict[loaded_process]["end_time"] = datetime.now().strftime("%H:%M")

        for process in collected_processes:
            incremented = False
            for loaded_process in self.data_dict["processes"]:
                if process == loaded_process:
                    #verify this
                    self.data_dict["processes"][loaded_process]["running"] = True
                    self.data_dict["processes"][loaded_process]["time"] += 3
                    incremented = True
                    break
            if not incremented:
                collected_processes[process]["running"] = True
                self.data_dict["processes"][process] = collected_processes[process]

        job_json = json.dumps(self.data_dict, indent=2)
        with open("/var/tmp/software_data.json", "w") as f:
            json.dump(self.data_dict, f, indent=2, sort_keys=True)
        return job_json

    def group_data_by_user(self):
        output = {}
        for job in self.data_dict["jobs"]:
            if job["user"] not in output:
                output[job["user"]] = [job]
            else:
                output[job["user"]].append(job)
        job_json = json.dumps(output, indent=2)
        with open("/var/tmp/software_user_data.json", "w") as f:
            json.dump(job_json, f)
        return job_json
